#!/usr/bin/perl

print STDERR "
                    :-} G R O M A C S {-:
                      contributed stuff

                    :-}  grompatch.pl {-:

";


use Getopt::Std;
$opt_l="../";
$opt_e=".orig";
$opt_m="install";$U="no";

getopts('l:e:m:Uvh') || die "ERROR in options, exiting\n";

$location=$opt_l;$location=~s/\/$//;
$ext=$opt_e;

$mode=$opt_m;
if ($opt_U){
    $mode="uninstall";$U="yes";
}


if ($opt_h){$HO="yes"} else{$HO="no"}
if($opt_v){$V=1;$VO="yes"}else{$VO="no"}

print STDERR"
      Option   Type  Value  Description
------------------------------------------------------
";

printf STDERR ("          -h   bool %9s  Print help info and quit\n",$HO);
printf STDERR ("          -l   free %9s  Installation location\n",$location."/");
printf STDERR ("          -m   enum %9s  Installation mode\n",$mode);
printf STDERR ("                               (install, uninstall, gather)\n",$mode);
printf STDERR ("          -U   bool %9s  Force uninstall\n",$U);
printf STDERR ("          -v   bool %9s  Be loud and noisy\n",$VO);


print STDERR"\n";
if ($opt_h){exit;}
printf STDERR ("          -U   bool %6s  Perform uninstall\n",$U);
$filelist="LIST_OF_MODIFIED_FILES.TXT";
open (FL,"$filelist") || die "FATAL: Cannot open mandatory file $filelist\n";

while(<FL>){
    chop;
    #file line
    if ($_=~/^[a-z]/){
	$_=~s/ +$//;
	$full=$location."/".$_;
	$file=$_;$file=~s%^.*\/([^\/]*)$%$1%;
	$backup=$location."/".$_;
	$backup.=$ext;
	if ($mode eq "install"){
	    if (-e $backup){
		$bb=$backup;
		$bb=~s%(^.*\/)([^\/]*)$%$1\#$2\#%;
		system ("mv $backup $bb");
		print STDERR ("mv $backup $bb\n") if $V;
		print STDERR "Back off! Renamed old backup file $backup to $bb\n";
	    }
	    system("cp $full $backup");
	    print STDERR ("cp $full $backup\n") if $V;
	    system("cp $file $full");
	    print STDERR ("cp $file $full\n") if $V;
	}
	elsif ($mode eq "uninstall"){
	    system("cp $backup $full");
	    print STDERR ("cp $backup $full\n") if $V;
	}
        # Aiding further developments :-)
 	elsif ($mode eq "gather"){
	    system("cp -p $full .");
	    print STDERR ("cp -p $full .\n") if $V;
	}
	else{die "FATAL: Invalid mode: $opt_m\n"}
    }

}






