#!/bin/csh

# Extracts structures from all trajectories at interval dt
# in pdb format

set program_suffix = _mumo
set molname = test 
# number of replicas (= No. of trajectory files)
set np=4 

# necessary to maintain parallell versions simultaneously, you
# also need to have the respective lib$program_suffix directories.
setenv LD_RUN_PATH /home/szpari/GROMACS/lib$program_suffix;
setenv LD_LIBRARY_PATH /home/szpari/GROMACS/lib$program_suffix;

# full molecule from default index groups
set group=1

# dt for trjconv
set dt=250


# Invoking trjconv

set i=0
while ($i < $np)
echo "trjconv$program_suffix -f $molname\_full$i\.trr -s $molname\_full$i\.tpr -o $molname\_full$i\_dt$dt\.pdb -dt $dt << HERE " > getpdb.sh
echo "$group\n" >> getpdb.sh
echo "HERE\n" >> getpdb.sh
chmod +x getpdb.sh
./getpdb.sh
@ i = $i + 1
end

rm getpdb.sh




