#!/usr/bin/perl

# Issuing a gromacs command for N replicas (from 0 to N-1)
# `#` characters will be replaced by the given number in I/O files
# Does not check the correctness of the file!!

print STDERR "
                    :-] G R O M A C S [-:
                        helpful tools

                   :-] multigromacs.pl  [-:

";

use Getopt::Std;

$opt_N=0;
$opt_C="uname -a";

getopts('N:C:hv') || die "ERROR in options, exiting\n";

if ($opt_h){$HO="yes"} else{$HO="no"}
if($opt_v){$V=1;$VO="yes"}else{$VO="no"}

print STDERR"
      Option   Type  Value  Description
------------------------------------------------------
";

printf STDERR ("          -h   bool %6s  Print help info and quit\n",$HO);
printf STDERR ("          -N    int %6s  Number of replicas to run program for\n",$N);
printf STDERR ("          -C   free \"%6s\"  Command\n",$C);
printf STDERR ("          -v   bool %9s  Be loud and noisy\n",$VO);

exit if $opt_h;

if ($opt_N == 0){die "Won't do anything for zero replicas! Use -N to specify a valid number!"}

for ($n=0; $n < $opt_N; $n++){

    $command=$opt_C;
    $command=~s/\#/$n/g;
    print STDERR "$command\n" if $V;
    system ("$command");

}

